--- /dev/null	Sun Aug 11 00:54:15 2013
+++ new/usr/src/uts/common/sys/fsd.h	Sun Aug 11 00:54:15 2013
@@ -0,0 +1,80 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2013 Damian Bogel.  All rights reserved.
+ */
+
+#ifndef _FSD_H
+#define	_FSD_H
+
+/*
+ * TODO: Describe the purpose of the file here.
+ */
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <sys/ksynch.h>
+#include <sys/list.h>
+#include <sys/types.h>
+#include <sys/vfs.h>
+
+
+#define	FSD_DEV_PATH	"/dev/fsd"
+
+/*
+ * Commands for ioctl().
+ */
+#define	FSDIOC	(('f' << 24) | ('s' << 16) | ('d' << 8))
+#define	FSD_GET_STATUS		(FSDIOC | 1)
+#define	FSD_ENABLE		(FSDIOC | 2)
+#define	FSD_DISABLE		(FSDIOC | 3)
+#define	FSD_DISTURB		(FSDIOC | 4)
+#define	FSD_NODISTURB		(FSDIOC | 5)
+#define	FSD_DISTURB_NEW		(FSDIOC | 6)
+#define	FSD_NODISTURB_NEW	(FSDIOC | 7)
+
+#define	FSD_ENTRY_NOT_FOUND	1
+#define	FSD_BAD_STAT		2
+#define	FSD_BAD_FD		3
+#define	FSD_NOT_ENABLED		4
+
+typedef struct fsd_stat {
+	uint64_t	fsds_read_less_chance;
+	uint64_t	fsds_read_less_r[2];	/* range */
+} fsd_stat_t;
+
+
+typedef struct fsd_ioc_stat {
+	int64_t		fsdis_mnt;
+	fsd_stat_t	fsdis_stat;
+} fsd_ioc_stat_t;
+
+/*
+ * Once a set of hooks is installed on a filesystem, there's no need
+ * to bother fsh if we want to change the parameters of disturbance.
+ * Intead, we use fsdsi_lock to protect the fsd_stat_int_t when it's being
+ * used and changed.
+ */
+typedef struct fsd_stat_int {
+	krwlock_t	fsdsi_lock; /* protects fsdsi_stat */
+	vfs_t		*fsdsi_vfsp;
+	fsd_stat_t	fsdsi_stat;
+	list_node_t	fsdsi_next;
+} fsd_stat_int_t;
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _FSD_H */
